﻿@page "/settings"

@using DayZLegacy.Components
@using DayZLegacy.Services
@using Shared
@inject NavigationManager NavigationManager

<Titlebar Title="@Title" OnGoBack="@HandleGoBack"/>

<div class="settings">
    <div class="d-flex justify-content-around p-1 rounded">
        <button class="w-100 rounded text-white @(_selectedTab == SettingsTab.Game ? "selected" : "")"
                @onclick="() => _selectedTab = SettingsTab.Game">
            Game
        </button>
        <button class="w-100 rounded text-white @(_selectedTab == SettingsTab.Debug ? "selected" : "")"
                @onclick="() => _selectedTab = SettingsTab.Debug">
            Debug
        </button>
        <button class="w-100 rounded text-white @(_selectedTab == SettingsTab.Launcher ? "selected" : "")"
                @onclick="() => _selectedTab = SettingsTab.Launcher">
            Launcher
        </button>
    </div>
    <div class="p-2 border-top">
        <div class="settings-container text-white d-flex justify-content-between">
            @switch (_selectedTab)
            {
                case SettingsTab.Game:
                    <ToggleSetting Value="@ConfigService.Settings.GameSettings.Renderer" 
                                   OnValueChanged=@HandleRendererChanged />
                    
                    <ToggleSetting Value="@ConfigService.Settings.GameSettings.Platform" 
                                   OnValueChanged=@HandlePlatformChanged />
                    
                    <ToggleSetting Value="@ConfigService.Settings.GameSettings.DisplayMode" 
                                   OnValueChanged=@HandleDisplayModeChanged />
                    break;
                    
                case SettingsTab.Debug:
                    <CheckboxSetting Title="Run as admin" 
                                     Value="@ConfigService.Settings.DebugSettings.RunAsAdmin" 
                                     OnValueChanged=@HandleRunAsAdminChanged />
                    
                    <CheckboxSetting Title="No logs" 
                                     Value="@ConfigService.Settings.DebugSettings.NoLogs" 
                                     OnValueChanged=@HandleNoLogsChanged />
                    
                    <CheckboxSetting Title="No console" 
                                     Value="@ConfigService.Settings.DebugSettings.NoConsole" 
                                     OnValueChanged=@HandleNoConsoleChanged />
                    break;
                    
                case SettingsTab.Launcher:
                    <BackgroundSetting />                 
                    break;
            }
        </div>
    </div>
</div>

@code {
    [Inject]
    private ConfigService ConfigService { get; set; } = default!;

    [Inject]
    private LauncherService LauncherService { get; set; } = default!;
    
    private const string Title = "Settings";
    private SettingsTab _selectedTab;

    private enum SettingsTab
    {
        Game = 0,
        Debug = 1,
        Launcher = 2
    }

    private void HandleSettingsChange()
    {
        ConfigService.SaveConfig();
    }
    
    private void HandleGoBack()
    {
        NavigationManager.NavigateTo("/");
    }
    
    private void HandleRendererChanged(Enum value)
    {
        ConfigService.Settings.GameSettings.Renderer = Enum.Parse<Renderer>(value.ToString());
        HandleSettingsChange();
    }
    
    private void HandleDisplayModeChanged(Enum value)
    {
        ConfigService.Settings.GameSettings.DisplayMode = Enum.Parse<DisplayMode>(value.ToString());
        HandleSettingsChange();
    }
    
    private void HandlePlatformChanged(Enum value)
    {
        ConfigService.Settings.GameSettings.Platform = Enum.Parse<Platform>(value.ToString());
        HandleSettingsChange();
    }
    
    private void HandleRunAsAdminChanged(bool value)
    {
        ConfigService.Settings.DebugSettings.RunAsAdmin = value;
        HandleSettingsChange();
    }
    
    private void HandleNoLogsChanged(bool value)
    {
        ConfigService.Settings.DebugSettings.NoLogs = value;
        HandleSettingsChange();
    }

    private void HandleNoConsoleChanged(bool value)
    {
        ConfigService.Settings.DebugSettings.NoConsole = value;
        HandleSettingsChange();
    }
}